#ifndef KERNEL_H
#define KERNEL_H

#include<iostream>
#include<map>
#include<vector>

class KernelCount;

class Grid {
public:
    int nullval = -1;
    std::map<std::string, int> metadata;
    std::vector<std::vector<int>> data;

    Grid() {}
    Grid(int rows, int cols) {
        metadata["rows"] = rows;
        metadata["cols"] = cols;

        for (int r = 0; r < rows; r++) {
            std::vector<int> line(cols, -1);
            data.push_back(line);
        }
    }
    std::string stats();
};

class DataGrid: public Grid {
public:
    DataGrid(): Grid() {}
    DataGrid(int rows, int cols): Grid(rows, cols) {}
    void read_from_file(const std::string&);
    DataGrid &apply_kernel(KernelCount &);
};

std::ostream &operator<<(std::ostream &, const DataGrid &);

class KernelGrid: public Grid {
public:
    KernelGrid(const int size): Grid(size, size) {
        metadata["rows"] = size;
        metadata["cols"] = size;
    }

    void reset();
    int size();
    virtual int calculate() = 0;
};

class KernelCount: public KernelGrid {
public:
    KernelCount(const int size): KernelGrid(size) {}
    int calculate();
};

#endif // KERNEL_H
