#include <iostream>
#include <chrono>
#include "kernel.h"

int main(int argc, char* argv[]) {
    if (argc != 3) {
        std::cerr << "Chyba: nutne zadat dva parametry - nazev souboru a velikost kernelu" << std::endl;
        return 1;
    }
    const std::string input_file = argv[1];
    const int kernel_size = atoi(argv[2]);

    auto start = std::chrono::high_resolution_clock::now();
    DataGrid grid = DataGrid();
    grid.read_from_file(input_file);
    std::cout << grid << std::endl;

    KernelCount kernel = KernelCount(kernel_size);
    DataGrid &ogrid = grid.apply_kernel(kernel);
    std::cout << ogrid << std::endl;
    std::cout << ogrid.stats() << std::endl;
    auto stop = std::chrono::high_resolution_clock::now();
    auto duration = std::chrono::duration_cast<std::chrono::milliseconds>(stop - start);
    std::cout << "---" << duration.count() / 1000. << " seconds ---" << std::endl;
    return 0;
}
