import time
import argparse

from kernel import DataGrid, KernelCount, KernelSum
# from kernel_np import DataGrid, KernelCount, KernelSum

def main(input_data, size):
    start_time = time.time()
    grid = DataGrid()
    grid.read_from_file(input_data)
    print(grid)
    kernel = KernelCount(int(size))
    ogrid = grid.apply_kernel(kernel)
    print(ogrid)
    print(ogrid.stats())
    print("--- {} seconds ---".format(time.time() - start_time))

if __name__ == "__main__":
    parser = argparse.ArgumentParser(
        'Moving window (kernel) demonstration'
    )
    parser.add_argument('-i', '--input', required=True, type=argparse.FileType('r'))
    parser.add_argument('-s', '--size', required=True)
    args = parser.parse_args()
    main(args.input, args.size)
