// Autor: Ales Cepek

#include <iostream>
#include "demo.h"

using std::cerr;

Demo::Demo(int t)
{
  dim = t;
  if (dim > 0) mem = new double[dim];
  
  cerr << "konstruktor " << t << "\n"; 
};

Demo::~Demo()
{
  cerr << "destruktor  " << dim << "\n";
  delete[] mem;
}

Demo::Demo(const Demo& d)
{
  cerr << "kopirovaci konstruktor " << d.dim << "\n";
  dim = d.dim;
  mem = new double[dim];
  for (int i=0; i<dim; i++) mem[i] = d.mem[i];
}

Demo::Demo(Demo&& d)
{
  cerr << "move konstruktor " << d.dim << "\n";
  dim = d.dim;
  mem = d.mem;
  d.dim = 0;
  d.mem = nullptr;
}

Demo& Demo::operator=(const Demo& d)
{
  cerr << "operator = " << d.dim << "\n";
  if (this != &d) {
    delete[] mem;
    dim = d.dim;
    mem = new double[dim];
    for (int i=0; i<dim; i++) mem[i] = d.mem[i];
  }

  return *this;
}

